#!/usr/bin/perl -w
####
# makemail.pl
# based on thh 020817
# some changes for exim4 from mbroemme
# some bugfixes of exim4 code from gnickels

$type = shift (@ARGV);
if (!defined($type) or $type ne '--aliases' and $type ne '--domains') {
	die "Usage: $0 --aliases OR $0 --domains\n";
};

while (<>) {
	local ($address,$target,$lhs,$rhs);
	($address,$target) = split;
	($lhs,$rhs) = split /\@/, $address;

	if (!grep /^$rhs$/, @domains) {
		push @domains, $rhs;
	};
 
	if ($lhs eq '') {
		if ($target ne 'error:nouser') {
			$catchall{$rhs} = $target;
		} 
	} elsif ($type eq '--aliases') {
		if (index($target, "@") < 0) {
			print "$lhs\@$rhs \t $target\@$rhs\n";
		} else {
			print "$lhs\@$rhs \t $target\n";
		}
	};
};

foreach $domain (@domains) {
	if ($type eq '--aliases') {
		if (exists($catchall{$domain})) {
			if (index($catchall{$domain}, "@") < 0) {
				print "*\@$domain\t".$catchall{$domain}."\@$domain\n";
			} else {
				print "*\@$domain\t".$catchall{$domain}."\n";
			}
		};
	} else {
		print "$domain\n";
	};
};
